<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @category   Forum
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.1 build:20090819
* @since      File available since Release 1.0.0
* @deprecated File deprecated in Release 3.0.0
*/

session_start();
require_once('bin/qtf_init.php');
include(Translate('qtf_adm.php'));
include(Translate('qtfm_export.php'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$arrYears = array(
  '*'=>'&lt; '.$L['All'].' &gt;',
  strval(date('Y'))=>strval(date('Y')),
  strval(date('Y')-1)=>strval(date('Y')-1),
  'old'=>'&lt; '.strval(date('Y')-1)
  );

if ( !isset($_SESSION['m_export']) )
{ 
  $_SESSION['m_export'] = array(
  'title'    =>'export_'.date('Ymd').'.txt',
  'format'   =>'CSV',
  'delimit'  =>';',
  'enclose'  =>'"',
  'null'     =>'NULL',
  'dropbbc'  =>'Y',
  'firstline'=>'Y');
}

$oVIP->selfurl = 'qtfm_export_adm.php';
$oVIP->selfname = $L['export']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['export']['Version'].' 2.1<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['submit']) )
{
  // read and check mandatory
  $_SESSION['m_export']['format']  = trim($_POST['format']);
  $_SESSION['m_export']['delimit'] = trim($_POST['delimiter']);
  $_SESSION['m_export']['enclose'] = $_POST['enclose'];  if ( get_magic_quotes_gpc() ) $_SESSION['m_export']['enclose'] = stripslashes($_POST['enclose']);
  $_SESSION['m_export']['null']    = trim($_POST['null']);
  if ( isset($_POST['dropbbc']) )   $_SESSION['m_export']['dropbbc']='Y';
  if ( isset($_POST['firstline']) ) $_SESSION['m_export']['firstline']='Y';
  if ( empty($_SESSION['m_export']['delimit']) ) $error=$L['export']['Delimiter'].S.$L['E_invalid'];
  
  // check values
  if ( empty($error) )
  {
    if ( strlen($_SESSION['m_export']['delimit'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['delimit']) ) $error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($_SESSION['m_export']['enclose'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['enclose']) ) $error=$L['export']['Encloser'].S.$L['E_invalid'];
    }
    if ( $_SESSION['m_export']['format']=='SQL' ) $_SESSION['m_export']['delimit'] = ',';
  }

  // check conflict
  $strEnclose = '"'; if ( $_SESSION['m_export']['enclose']=='"' || $_SESSION['m_export']['enclose']=="'" ) $strEnclose = '';
  $strDelimit = ';'; if ( $_SESSION['m_export']['delimit']==';' ) $strDelimit = ',';

  // EXPORT COUNT
  if ( empty($error) )
  {
    // query
    $strWhere = ' WHERE ';
    if ( $_POST['forum']!='*' ) { $strWhere .= ' p.forum='.$_POST['forum']; } else { $strWhere .= 'p.forum>=0'; }
    if ( $_POST['year']!='*' )
    {
      if ( $_POST['year']=='old' ) { $strOp='<'; $_POST['year']=strval(Date('Y')-1); } else { $strOp='='; }
      switch(substr($oDB->type,0,5))
      {
      case 'mysql': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'mssql': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'pg':    $strWhere .= ' AND SUBSTRING(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'ibase': $strWhere .= ' AND SUBSTRING(p.issuedate FROM 1 FOR 4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'sqlit': $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'acces': $strWhere .= ' AND LEFT(p.issuedate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'db2':   $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'oci':   $strWhere .= ' AND SUBSTR(p.issuedate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      default: die('Unknown db type '.$oDB->type);
      }
    }

    // count
    $oDB->Query('SELECT count(*) as countid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id '.$strWhere);
    $row=$oDB->Getrow();
    if ( $row['countid']==0 ) $error='No data found';
  }

  // ------
  // EXPORT
  // ------
  if ( empty($error) )
  {
    if (!headers_sent())
    {
      header('Content-Type: text/plain; charset='.QTF_HTML_CHAR);
      header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'"');
    }

    if ( $_SESSION['m_export']['firstline']=='Y' )
    {
      echo ($_SESSION['m_export']['format']=='SQL' ? '# ' : '').$_SESSION['m_export']['enclose']."id".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."forum".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."topic".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."type".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."username".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."title".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."issuedate".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."numid".$_SESSION['m_export']['enclose'].$_SESSION['m_export']['delimit'].$_SESSION['m_export']['enclose']."textmsg".$_SESSION['m_export']['enclose']."\r\n";
    }

    $oDB->Query('SELECT p.id,p.forum,p.topic,p.type,p.username,p.title,p.issuedate,p.textmsg,t.numid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id '.$strWhere);
    While( $row=$oDB->Getrow() )
    {
      $str  = $row['id'].$_SESSION['m_export']['delimit'];
      $str .= $row['forum'].$_SESSION['m_export']['delimit'];
      $str .= $row['topic'].$_SESSION['m_export']['delimit'];
      $str .= (empty($row['type']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$row['type'].$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];
      
        // username pre-process
        $txt = $row['username']; 
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);

      $str .= (empty($row['username'])  ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];

        // title pre-process
        $txt = $row['title']; 
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);

      $str .= (empty($row['title'])     ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];

      $str .= (empty($row['issuedate']) ? $_SESSION['m_export']['null'] : $_SESSION['m_export']['enclose'].$row['issuedate'].$_SESSION['m_export']['enclose'] ).$_SESSION['m_export']['delimit'];
      $str .= $row['numid'].$_SESSION['m_export']['delimit'];

        // text pre-process
        $txt = $row['textmsg']; 
        if ( $_SESSION['m_export']['dropbbc']=='Y' ) $bbctxt = QTbbc($txt,'drop');
        $txt = QTconv($txt,'-4');
        $txt = str_replace($_SESSION['m_export']['enclose'],$strEnclose,$txt);
        $txt = str_replace($_SESSION['m_export']['delimit'],$strDelimit,$txt);
        $txt = str_replace("\r\n","\\n",$txt);
        $txt = str_replace("\n","\\n",$txt);

      $str .= $_SESSION['m_export']['enclose'].$txt.$_SESSION['m_export']['enclose'];
      
      if ( $_SESSION['m_export']["format"]=='CSV' )
      {
      $content = $str."\r\n";
      }
      else
      {
      $content = 'INSERT INTO '.TABPOST.' (id,forum,topic,type,username,title,issuedate,numid,textmsg) VALUES ('.$str.")\r\n";
      }

      echo $content;
    }
    exit;
  }
}

// --------
// HTML START
// --------

$bJava=true;
include('qtf_adm_p_header.php');
include('qtf_adm_p_title.php');

// FORM

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['export']['Settings'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="format">',$L['export']['Format'],'</label></td>
<td class="td_o"><select id="format" name="format">
<option value="CSV"',($_SESSION['m_export']['format']=='CSV' ? QSEL : ''),'>',$L['export']['Csv'],'</option>
<option value="SQL"',($_SESSION['m_export']['format']=='SQL' ? QSEL : ''),'>',$L['export']['Sql'],'</option>
</select></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="delimiter">',$L['export']['Delimiter'],'</label></td>
<td class="td_o"><input type="text" id="delimiter" name="delimiter" size="1" maxlength="2" value="',$_SESSION['m_export']['delimit'],'"/></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="enclose">',$L['export']['Encloser'],'</label></td>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="2" value="',htmlspecialchars($_SESSION['m_export']['enclose']),'"/></td>
<td class="td_o"><span class="help">',$L['export']['H_Encloser'],'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="null">',$L['export']['Replace_null'],'</label></td>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$_SESSION['m_export']['null'],'"/></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['export']['First_line'],'</td>
<td class="td_o" colspan="2"><input type="checkbox" id="firstline" name="firstline"',($_SESSION['m_export']['firstline']=='Y' ? QCHE : ''),'/><label for="firstline">',$L['export']['H_First_line'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['export']['Content'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="forum">',$L['Section'],'</label></td>
<td class="td_o" colspan="2">
<select id="forum" name="forum" size="1">
<option value="*">&lt; ',$L['All'],' &gt;</option>',QTasTag(GetSectionTitles('A')),'</select>
</td>
</tr>
';
echo '<tr class="data_o">';
echo '<td class="th_o th_o_first">',$L['Messages'],'</td>';
echo '<td class="td_o"><select name="year" size="1">';
foreach($arrYears as $intKey=>$strValue)
{
echo '<option value="',$intKey,'">',$strValue,'</option>';
}
echo '</select></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['export']['Drop_bbc'],'</td>
<td class="td_o" colspan="2"><input type="checkbox" id="dropbbc" name="dropbbc"',($_SESSION['m_export']['dropbbc']=='Y' ? QCHE : ''),'/><label for="dropbbc">',$L['export']['H_Drop_bbc'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="submit" value="',$L['Ok'],'"/></td>
</tr>
';
echo '</table>';
echo '</form>';

// HTML END

include('qtf_adm_p_footer.php');

?>